package cn.com.infosec.asn1;

import java.io.ByteArrayOutputStream;
import java.io.OutputStream;

public class DERSequenceGenerator extends DERGenerator {
   private final ByteArrayOutputStream _bOut;

   public DERSequenceGenerator(OutputStream out) {
      DERSequenceGenerator var10000 = this;
      super(out);
      ByteArrayOutputStream var2;
      var2 = new ByteArrayOutputStream.<init>();
      var10000._bOut = var2;
   }

   public DERSequenceGenerator(OutputStream out, int tagNo, boolean isExplicit) {
      DERSequenceGenerator var10000 = this;
      super(out, tagNo, isExplicit);
      ByteArrayOutputStream var4;
      var4 = new ByteArrayOutputStream.<init>();
      var10000._bOut = var4;
   }

   public void addObject(DEREncodable object) {
      object.getDERObject().encode(new DEROutputStream(this._bOut));
   }

   public OutputStream getRawOutputStream() {
      return this._bOut;
   }

   public void close() {
      this.writeDEREncoded(48, this._bOut.toByteArray());
   }
}
